--------------------------------------------------------------------------------
--"Objects transform reader"
--"produced by apras();"
--"http://www.apras.net/"
--"apras@mail.apras.net"
--
--
--memo
--"Objects transform writer"ot@CǂݍŁA
--IuWFNg̃IuWFNgɑ΂ăgXtH[l
--蓖ĂXNvgłB
--ǂݍݎAI[gL[IɂĂƂ̃t[ɃL[ł܂B
--memo
--It is a script which reads the file which "Objects transform writer" 
--wrote out and assigns a transformer form value to the object of the said object name.
--At the time of reading, if the "auto key" is turned ON, a key will be struck by the frame.
--
--
--g
--"otReader.ms"hbOĂB
--Usage
--Please drag "otReader.ms".
--
--
--History
--2008/01/11 1.00	First release
--
--
--ɂ񂵂ČlIɎĝ́BĔzzƂ́~B
--zƂ̓[Rgł肢܂B
--------------------------------------------------------------------------------
(
	--local debug = newScript()
	
	struct NodeValue
	(
		name,
		matrix
	)
	
	fn ReadObjectList =
	(
		local in_name = getOpenFileName()
		local objectArray = #()
		if (in_name != undefined) then
		(
			in_file = openFile in_name
			if in_file != undefined then
			(
				while not eof in_file do
				(
					local l_nodeValue = NodeValue ""
					local nodeParse = readDelimitedString in_file ";"
					local strParse = filterString nodeParse "=>"
					l_nodeValue.name = (filterString strParse[1] "\n")[1]
					l_nodeValue.matrix = strParse[2]
					append objectArray l_nodeValue
				)
				close in_file
				return objectArray
			)else
			(
				return objectArray
			)
		)else
		(
			return objectArray
		)
	)
	
	
	fn selectObject sArray =
	(
		if (sArray.count > 0) then
		(
			animate on
			(
				for item in sArray do
				(
					--print item.name
					targetNode = getNodeByName item.name exact:true 
					targetNode.transform = (execute item.matrix)
					--format "%\n" item.name to:debug
					--format "%\n" item.matrix to:debug
					--format "------------------------\n"  to:debug				
				)
			)
			animate off
			return true
		)else(
			return false
		)
	)
	
	if (selectObject (ReadObjectList())) then
	(
		messageBox "Successfully transform."
	)else(
		messageBox "Transform failed."
	)

)