--------------------------------------------------------------------------------
--"Objects transform writer"
--"produced by apras();"
--"http://www.apras.net/"
--"apras@mail.apras.net"
--
--
--memo
--IIuWFNg()̃gXtH[(ʒuA]AXP[)
--w肵eLXgt@CɏoXNvgB
--̓IȎgł́A{[OŃAj[VtA
--EGCĝ߃{[Ȍ|[Yɖ߂ꍇA
--ʃV[̃IuWFNgɈʒu킹AoȂꍇA
--Aj[V̓ǂݍ݂ł͏o邪A}bv̂ʓ|XB
--óA_ł̃t[ŏo܂B
--memo
--The script written out to the text file which specified the transformer form (position, rotation, scale)
--information on a selection object (plurality-izing). 
--The beginning is written out with the frame in this time.
--
--
--g
--"otWriter.ms"hbOĂB
--Usage
--Please drag "otWriter.ms".
--
--
--History
--2008/01/11 1.00	First release
--
--
--ɂ񂵂ČlIɎĝ́BĔzzƂ́~B
--zƂ̓[Rgł肢܂B
--------------------------------------------------------------------------------
(
	
	local outPutFlag
	
	fn getObjectList =
	(
		local objectArrary = #()
		if ($ != undefined) then
		(
			outPutFlag = true
			for item in $ do
			(
				append objectArrary item
			)
		)else
		(
			outPutFlag = false
		)
		return objectArrary
	)
	
	
	fn listWriter sArray =
	(
		if (outPutFlag) then
		(
			local output_name = getSaveFileName caption:"select Export File" types:"text (*.txt)|*.txt|All Files (*.*)|*.*|"
			if (output_name != undefined) then
			(
				output_file = createfile output_name
				sArrayCount = sArray.count
				for i=1 to sArrayCount do
				(
					format "%=>%;" (sArray[i].name as string) (sArray[i].transform as string) to:output_file
					if ( i != sArrayCount ) then ( format "\n" to:output_file )
				)
				
				close output_file
				return true
			)else
			(
				return false
			)
		)else
		(
			return false
		)
	)
	
	if ($ != undefined) then
	(
		if (listWriter (getObjectList())) then
		(
			messageBox "Writing has been completed."
		)else(
			messageBox "Failed to write."
		)
	)else
	(
		messageBox "Object has not been selected."
	)
)